--- old/usr/src/uts/i86pc/io/pcplusmp/apic_regops.c	2014-01-03 22:11:55.283545367 -0500
+++ new/usr/src/uts/i86pc/io/pcplusmp/apic_regops.c	2014-01-03 22:11:55.289076879 -0500
@@ -94,7 +94,6 @@
 void apic_send_EOI();
 void apic_send_directed_EOI(uint32_t irq);
 
-#define	X2APIC_CPUID_BIT	21
 #define	X2APIC_ENABLE_BIT	10
 
 /*
@@ -109,7 +108,7 @@
 static void
 local_apic_write(uint32_t reg, uint64_t value)
 {
-	apicadr[reg] = (uint32_t)value;
+	LOCAL_APIC_WRITE_REG(reg, (uint32_t)value);
 }
 
 static int
@@ -133,7 +132,7 @@
 	if (apic_have_32bit_cr8)
 		setcr8((ulong_t)(value >> APIC_IPL_SHIFT));
 	else
-		apicadr[APIC_TASK_REG] = (uint32_t)value;
+		LOCAL_APIC_WRITE_REG(APIC_TASK_REG, (uint32_t)value);
 #endif
 }
 
@@ -233,15 +232,10 @@
 int
 apic_detect_x2apic(void)
 {
-	struct cpuid_regs cp;
-
 	if (x2apic_enable == 0)
 		return (0);
 
-	cp.cp_eax = 1;
-	(void) __cpuid_insn(&cp);
-
-	return ((cp.cp_ecx & (0x1 << X2APIC_CPUID_BIT)) ? 1 : 0);
+	return is_x86_feature(x86_featureset, X86FSET_X2APIC);
 }
 
 void
